// SelfSignedCertDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ezManagerLib_Example.h"
#include "SelfSignedCertDlg.h"
#include "afxdialogex.h"


// CSelfSignedCertDlg dialog

IMPLEMENT_DYNAMIC(CSelfSignedCertDlg, CDialog)

CSelfSignedCertDlg::CSelfSignedCertDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSelfSignedCertDlg::IDD, pParent)
	, m_opt_2(_T("INCHEON"))
	, m_opt_3(_T("MICHUHOL-GU"))
	, m_opt_4(_T("SOLLAE SYSTEMS"))
	, m_opt_5(_T("Research Team"))
	, m_opt_6(_T("www.sollae.co.kr"))
	, m_opt_7(_T("support@sollae.co.kr"))
{
	m_opt_0 = 1024;
}

CSelfSignedCertDlg::~CSelfSignedCertDlg()
{

}

void CSelfSignedCertDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Text(pDX, IDC_EDIT_OPT_2, m_opt_2);
	DDX_Text(pDX, IDC_EDIT_OPT_3, m_opt_3);
	DDX_Text(pDX, IDC_EDIT_OPT_4, m_opt_4);
	DDX_Text(pDX, IDC_EDIT_OPT_5, m_opt_5);
	DDX_Text(pDX, IDC_EDIT_OPT_6, m_opt_6);
	DDX_Text(pDX, IDC_EDIT_OPT_7, m_opt_7);
	DDX_Control(pDX, IDC_COMBO1, m_rsa_key_len_ctrl);
	DDX_Control(pDX, IDC_COMBO2, m_country_code_ctrl);
}


BEGIN_MESSAGE_MAP(CSelfSignedCertDlg, CDialog)
	ON_BN_CLICKED(IDOK, &CSelfSignedCertDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CSelfSignedCertDlg::OnBnClickedCancel)
	ON_CBN_SELCHANGE(IDC_COMBO2, &CSelfSignedCertDlg::OnCbnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON_DO, &CSelfSignedCertDlg::OnBnClickedButtonDo)
END_MESSAGE_MAP()


// CSelfSignedCertDlg message handlers

struct country
{
	char *code;
	char *name;
};

struct country countries[]=
{
	{"AD","Andorra"},
	{"AE","United Arab Emirates"},
	{"AF","Afghanistan"},
	{"AG","Antigua and Barbuda"},
	{"AI","Anguilla"},
	{"AL","Albania"},
	{"AM","Armenia"},
	{"AN","Netherlands Antilles"},
	{"AO","Angola"},
	{"AQ","Antarctica"},
	{"AR","Argentina"},
	{"AS","American Samoa"},
	{"AT","Austria"},
	{"AU","Australia"},
	{"AW","Aruba"},
	{"AX","Aland Islands"},
	{"AZ","Azerbaijan"},
	{"BA","Bosnia and Herzegovina"},
	{"BB","Barbados"},
	{"BD","Bangladesh"},
	{"BE","Belgium"},
	{"BF","Burkina Faso"},
	{"BG","Bulgaria"},
	{"BH","Bahrain"},
	{"BI","Burundi"},
	{"BJ","Benin"},
	{"BM","Bermuda"},
	{"BN","Brunei Darussalam"},
	{"BO","Bolivia"},
	{"BR","Brazil"},
	{"BS","Bahamas"},
	{"BT","Bhutan"},
	{"BV","Bouvet Island"},
	{"BW","Botswana"},
	{"BY","Belarus"},
	{"BZ","Belize"},
	{"CA","Canada"},
	{"CC","Cocos (Keeling) Islands"},
	{"CD","Congo, the Democratic Republic of the"},
	{"CF","Central African Republic"},
	{"CG","Congo"},
	{"CH","Switzerland"},
	{"CI","Cote d'Ivoire"},
	{"CK","Cook Islands"},
	{"CL","Chile"},
	{"CM","Cameroon"},
	{"CN","China"},
	{"CO","Colombia"},
	{"CR","Costa Rica"},
	{"CU","Cuba"},
	{"CV","Cape Verde"},
	{"CX","Christmas Island"},
	{"CY","Cyprus"},
	{"CZ","Czech Republic"},
	{"DE","Germany"},
	{"DJ","Djibouti"},
	{"DK","Denmark"},
	{"DM","Dominica"},
	{"DO","Dominican Republic"},
	{"DZ","Algeria"},
	{"EC","Ecuador"},
	{"EE","Estonia"},
	{"EG","Egypt"},
	{"EH","Western Sahara"},
	{"ER","Eritrea"},
	{"ES","Spain"},
	{"ET","Ethiopia"},
	{"FI","Finland"},
	{"FJ","Fiji"},
	{"FK","Falkland Islands (Malvinas)"},
	{"FM","Micronesia, Federated States of"},
	{"FO","Faroe Islands"},
	{"FR","France"},
	{"GA","Gabon"},
	{"GB","United Kingdom"},
	{"GD","Grenada"},
	{"GE","Georgia"},
	{"GF","French Guiana"},
	{"GG","Guernsey"},
	{"GH","Ghana"},
	{"GI","Gibraltar"},
	{"GL","Greenland"},
	{"GM","Gambia"},
	{"GN","Guinea"},
	{"GP","Guadeloupe"},
	{"GQ","Equatorial Guinea"},
	{"GR","Greece"},
	{"GS","South Georgia and the South Sandwich Islands"},
	{"GT","Guatemala"},
	{"GU","Guam"},
	{"GW","Guinea-Bissau"},
	{"GY","Guyana"},
	{"HK","Hong Kong"},
	{"HM","Heard Island and McDonald Islands"},
	{"HN","Honduras"},
	{"HR","Croatia"},
	{"HT","Haiti"},
	{"HU","Hungary"},
	{"ID","Indonesia"},
	{"IE","Ireland"},
	{"IL","Israel"},
	{"IM","Isle of Man"},
	{"IN","India"},
	{"IO","British Indian Ocean Territory"},
	{"IQ","Iraq"},
	{"IR","Iran, Islamic Republic of"},
	{"IS","Iceland"},
	{"IT","Italy"},
	{"JE","Jersey"},
	{"JM","Jamaica"},
	{"JO","Jordan"},
	{"JP","Japan"},
	{"KE","Kenya"},
	{"KG","Kyrgyzstan"},
	{"KH","Cambodia"},
	{"KI","Kiribati"},
	{"KM","Comoros"},
	{"KN","Saint Kitts and Nevis"},
	{"KP","Korea, Democratic People's Republic of"},
	{"KR","Korea, Republic of"},
	{"KW","Kuwait"},
	{"KY","Cayman Islands"},
	{"KZ","Kazakhstan"},
	{"LA","Lao People's Democratic Republic"},
	{"LB","Lebanon"},
	{"LC","Saint Lucia"},
	{"LI","Liechtenstein"},
	{"LK","Sri Lanka"},
	{"LR","Liberia"},
	{"LS","Lesotho"},
	{"LT","Lithuania"},
	{"LU","Luxembourg"},
	{"LV","Latvia"},
	{"LY","Libya"},
	{"MA","Morocco"},
	{"MC","Monaco"},
	{"MD","Moldova, Republic of"},
	{"ME","Montenegro"},
	{"MG","Madagascar"},
	{"MH","Marshall Islands"},
	{"MK","Macedonia, the former Yugoslav Republic of"},
	{"ML","Mali"},
	{"MM","Myanmar"},
	{"MN","Mongolia"},
	{"MO","Macao"},
	{"MP","Northern Mariana Islands"},
	{"MQ","Martinique"},
	{"MR","Mauritania"},
	{"MS","Montserrat"},
	{"MT","Malta"},
	{"MU","Mauritius"},
	{"MV","Maldives"},
	{"MW","Malawi"},
	{"MX","Mexico"},
	{"MY","Malaysia"},
	{"MZ","Mozambique"},
	{"NA","Namibia"},
	{"NC","New Caledonia"},
	{"NE","Niger"},
	{"NF","Norfolk Island"},
	{"NG","Nigeria"},
	{"NI","Nicaragua"},
	{"NL","Netherlands"},
	{"NO","Norway"},
	{"NP","Nepal"},
	{"NR","Nauru"},
	{"NU","Niue"},
	{"NZ","New Zealand"},
	{"OM","Oman"},
	{"PA","Panama"},
	{"PE","Peru"},
	{"PF","French Polynesia"},
	{"PG","Papua New Guinea"},
	{"PH","Philippines"},
	{"PK","Pakistan"},
	{"PL","Poland"},
	{"PM","Saint Pierre and Miquelon"},
	{"PN","Pitcairn"},
	{"PR","Puerto Rico"},
	{"PS","Palestinian Territory"},
	{"PT","Portugal"},
	{"PW","Palau"},
	{"PY","Paraguay"},
	{"QA","Qatar"},
	{"RE","Reunion"},
	{"RO","Romania"},
	{"RS","Serbia"},
	{"RU","Russian Federation"},
	{"RW","Rwanda"},
	{"SA","Saudi Arabia"},
	{"SB","Solomon Islands"},
	{"SC","Seychelles"},
	{"SD","Sudan"},
	{"SE","Sweden"},
	{"SG","Singapore"},
	{"SH","Saint Helena"},
	{"SI","Slovenia"},
	{"SJ","Svalbard and Jan Mayen"},
	{"SK","Slovakia"},
	{"SL","Sierra Leone"},
	{"SM","San Marino"},
	{"SN","Senegal"},
	{"SO","Somalia"},
	{"SR","Suriname"},
	{"ST","Sao Tome and Principe"},
	{"SV","El Salvador"},
	{"SY","Syrian Arab Republic"},
	{"SZ","Swaziland"},
	{"TC","Turks and Caicos Islands"},
	{"TD","Chad"},
	{"TG","Togo"},
	{"TH","Thailand"},
	{"TJ","Tajikistan"},
	{"TK","Tokelau"},
	{"TL","Timor-Leste"},
	{"TM","Turkmenistan"},
	{"TN","Tunisia"},
	{"TO","Tonga"},
	{"TR","Turkey"},
	{"TT","Trinidad and Tobago"},
	{"TV","Tuvalu"},
	{"TW","Taiwan, Province of China"},
	{"TZ","Tanzania, United Republic of"},
	{"UA","Ukraine"},
	{"UG","Uganda"},
	{"US","United States"},
	{"UY","Uruguay"},
	{"UZ","Uzbekistan"},
	{"VA","Holy See (Vatican City State)"},
	{"VC","Saint Vincent and the Grenadines"},
	{"VE","Venezuela"},
	{"VG","Virgin Islands, British"},
	{"VI","Virgin Islands, U.S."},
	{"VN","Viet Nam"},
	{"VU","Vanuatu"},
	{"WF","Wallis and Futuna"},
	{"WS","Samoa"},
	{"YE","Yemen"},
	{"YT","Mayotte"},
	{"ZA","South Africa"},
	{"ZM","Zambia"},
	{"ZW","Zimbabwe"},
	{"",""}
};

BOOL CSelfSignedCertDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// TODO:  Add extra initialization here

	this->m_rsa_key_len_ctrl.SetCurSel(0);

	int c_index = 0;
	struct country *c;

	while(1)
	{
		c = &countries[c_index];
		CString s; 
		s.Format(_T("%s"), c->name);

		if ( !s.CompareNoCase(_T("")) )
			break;

		c_index++;

		int index = this->m_country_code_ctrl.AddString(s);
		if ( index != CB_ERR && index != CB_ERRSPACE )
			this->m_country_code_ctrl.SetItemDataPtr(index, c->code);
	}
	
	this->m_country_code_ctrl.SelectString(-1, _T("Korea, Republic of"));
	this->m_opt_6 = _T("10.1.0.1");

	UpdateData(FALSE);

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CSelfSignedCertDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	//

	// OnOK();
}

void CSelfSignedCertDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	if ( MessageBox("Are you sure to cancel?", "Self Signed Certificates", MB_YESNO | MB_ICONQUESTION) == IDYES )
		OnCancel();
}

void CSelfSignedCertDlg::OnCbnSelchangeCombo2()
{
	// TODO: Add your control notification handler code here
}


void CSelfSignedCertDlg::OnBnClickedButtonDo()
{
	// TODO: Add your control notification handler code here
	if ( !UpdateData(TRUE) ) return;

	int		index	= this->m_country_code_ctrl.GetCurSel();
	char	*c_code = (char*)this->m_country_code_ctrl.GetItemDataPtr(index);

	this->m_opt_1.Format(_T("%s"), c_code);

	switch ( this->m_rsa_key_len_ctrl.GetCurSel() )
	{
	case 0: // 1024
		this->m_opt_0 = 1024;
		break;
	case 1: // 1536
		this->m_opt_0 = 1536;
		break;
	case 2: // 2048
		this->m_opt_0 = 2048;
		break;
	}

	EndDialog(IDOK);
}
